# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .resources.account_details.client import AccountDetailsClient, AsyncAccountDetailsClient
from .resources.account_token.client import AccountTokenClient, AsyncAccountTokenClient
from .resources.activities.client import ActivitiesClient, AsyncActivitiesClient
from .resources.applications.client import ApplicationsClient, AsyncApplicationsClient
from .resources.async_passthrough.client import AsyncAsyncPassthroughClient
from .resources.async_passthrough.client import (
    AsyncPassthroughClient as resources_ats_resources_async_passthrough_client_AsyncPassthroughClient,
)
from .resources.attachments.client import AsyncAttachmentsClient, AttachmentsClient
from .resources.available_actions.client import AsyncAvailableActionsClient, AvailableActionsClient
from .resources.candidates.client import AsyncCandidatesClient, CandidatesClient
from .resources.delete_account.client import AsyncDeleteAccountClient, DeleteAccountClient
from .resources.departments.client import AsyncDepartmentsClient, DepartmentsClient
from .resources.eeocs.client import AsyncEeocsClient, EeocsClient
from .resources.force_resync.client import AsyncForceResyncClient, ForceResyncClient
from .resources.generate_key.client import AsyncGenerateKeyClient, GenerateKeyClient
from .resources.interviews.client import AsyncInterviewsClient, InterviewsClient
from .resources.issues.client import AsyncIssuesClient, IssuesClient
from .resources.job_interview_stages.client import AsyncJobInterviewStagesClient, JobInterviewStagesClient
from .resources.jobs.client import AsyncJobsClient, JobsClient
from .resources.link_token.client import AsyncLinkTokenClient, LinkTokenClient
from .resources.linked_accounts.client import AsyncLinkedAccountsClient, LinkedAccountsClient
from .resources.offers.client import AsyncOffersClient, OffersClient
from .resources.offices.client import AsyncOfficesClient, OfficesClient
from .resources.passthrough.client import (
    AsyncPassthroughClient as resources_ats_resources_passthrough_client_AsyncPassthroughClient,
)
from .resources.passthrough.client import PassthroughClient
from .resources.regenerate_key.client import AsyncRegenerateKeyClient, RegenerateKeyClient
from .resources.reject_reasons.client import AsyncRejectReasonsClient, RejectReasonsClient
from .resources.scorecards.client import AsyncScorecardsClient, ScorecardsClient
from .resources.selective_sync.client import AsyncSelectiveSyncClient, SelectiveSyncClient
from .resources.sync_status.client import AsyncSyncStatusClient, SyncStatusClient
from .resources.tags.client import AsyncTagsClient, TagsClient
from .resources.users.client import AsyncUsersClient, UsersClient
from .resources.webhook_receivers.client import AsyncWebhookReceiversClient, WebhookReceiversClient


class AtsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.account_details = AccountDetailsClient(client_wrapper=self._client_wrapper)
        self.account_token = AccountTokenClient(client_wrapper=self._client_wrapper)
        self.activities = ActivitiesClient(client_wrapper=self._client_wrapper)
        self.applications = ApplicationsClient(client_wrapper=self._client_wrapper)
        self.async_passthrough = resources_ats_resources_async_passthrough_client_AsyncPassthroughClient(
            client_wrapper=self._client_wrapper
        )
        self.attachments = AttachmentsClient(client_wrapper=self._client_wrapper)
        self.available_actions = AvailableActionsClient(client_wrapper=self._client_wrapper)
        self.candidates = CandidatesClient(client_wrapper=self._client_wrapper)
        self.delete_account = DeleteAccountClient(client_wrapper=self._client_wrapper)
        self.departments = DepartmentsClient(client_wrapper=self._client_wrapper)
        self.eeocs = EeocsClient(client_wrapper=self._client_wrapper)
        self.generate_key = GenerateKeyClient(client_wrapper=self._client_wrapper)
        self.interviews = InterviewsClient(client_wrapper=self._client_wrapper)
        self.issues = IssuesClient(client_wrapper=self._client_wrapper)
        self.job_interview_stages = JobInterviewStagesClient(client_wrapper=self._client_wrapper)
        self.jobs = JobsClient(client_wrapper=self._client_wrapper)
        self.link_token = LinkTokenClient(client_wrapper=self._client_wrapper)
        self.linked_accounts = LinkedAccountsClient(client_wrapper=self._client_wrapper)
        self.offers = OffersClient(client_wrapper=self._client_wrapper)
        self.offices = OfficesClient(client_wrapper=self._client_wrapper)
        self.passthrough = PassthroughClient(client_wrapper=self._client_wrapper)
        self.regenerate_key = RegenerateKeyClient(client_wrapper=self._client_wrapper)
        self.reject_reasons = RejectReasonsClient(client_wrapper=self._client_wrapper)
        self.scorecards = ScorecardsClient(client_wrapper=self._client_wrapper)
        self.selective_sync = SelectiveSyncClient(client_wrapper=self._client_wrapper)
        self.sync_status = SyncStatusClient(client_wrapper=self._client_wrapper)
        self.force_resync = ForceResyncClient(client_wrapper=self._client_wrapper)
        self.tags = TagsClient(client_wrapper=self._client_wrapper)
        self.users = UsersClient(client_wrapper=self._client_wrapper)
        self.webhook_receivers = WebhookReceiversClient(client_wrapper=self._client_wrapper)


class AsyncAtsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.account_details = AsyncAccountDetailsClient(client_wrapper=self._client_wrapper)
        self.account_token = AsyncAccountTokenClient(client_wrapper=self._client_wrapper)
        self.activities = AsyncActivitiesClient(client_wrapper=self._client_wrapper)
        self.applications = AsyncApplicationsClient(client_wrapper=self._client_wrapper)
        self.async_passthrough = AsyncAsyncPassthroughClient(client_wrapper=self._client_wrapper)
        self.attachments = AsyncAttachmentsClient(client_wrapper=self._client_wrapper)
        self.available_actions = AsyncAvailableActionsClient(client_wrapper=self._client_wrapper)
        self.candidates = AsyncCandidatesClient(client_wrapper=self._client_wrapper)
        self.delete_account = AsyncDeleteAccountClient(client_wrapper=self._client_wrapper)
        self.departments = AsyncDepartmentsClient(client_wrapper=self._client_wrapper)
        self.eeocs = AsyncEeocsClient(client_wrapper=self._client_wrapper)
        self.generate_key = AsyncGenerateKeyClient(client_wrapper=self._client_wrapper)
        self.interviews = AsyncInterviewsClient(client_wrapper=self._client_wrapper)
        self.issues = AsyncIssuesClient(client_wrapper=self._client_wrapper)
        self.job_interview_stages = AsyncJobInterviewStagesClient(client_wrapper=self._client_wrapper)
        self.jobs = AsyncJobsClient(client_wrapper=self._client_wrapper)
        self.link_token = AsyncLinkTokenClient(client_wrapper=self._client_wrapper)
        self.linked_accounts = AsyncLinkedAccountsClient(client_wrapper=self._client_wrapper)
        self.offers = AsyncOffersClient(client_wrapper=self._client_wrapper)
        self.offices = AsyncOfficesClient(client_wrapper=self._client_wrapper)
        self.passthrough = resources_ats_resources_passthrough_client_AsyncPassthroughClient(
            client_wrapper=self._client_wrapper
        )
        self.regenerate_key = AsyncRegenerateKeyClient(client_wrapper=self._client_wrapper)
        self.reject_reasons = AsyncRejectReasonsClient(client_wrapper=self._client_wrapper)
        self.scorecards = AsyncScorecardsClient(client_wrapper=self._client_wrapper)
        self.selective_sync = AsyncSelectiveSyncClient(client_wrapper=self._client_wrapper)
        self.sync_status = AsyncSyncStatusClient(client_wrapper=self._client_wrapper)
        self.force_resync = AsyncForceResyncClient(client_wrapper=self._client_wrapper)
        self.tags = AsyncTagsClient(client_wrapper=self._client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=self._client_wrapper)
        self.webhook_receivers = AsyncWebhookReceiversClient(client_wrapper=self._client_wrapper)
