# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .benefit_employee import BenefitEmployee
from .remote_data import RemoteData

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Benefit(pydantic.BaseModel):
    """
    # The Benefit Object
    ### Description
    The `Benefit` object is used to represent a benefit that an employee has enrolled in.

    ### Usage Example
    Fetch from the `LIST Benefits` endpoint and filter by `ID` to show all benefits.
    """

    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic.Field(description="The third-party API ID of the matching object.")
    employee: typing.Optional[BenefitEmployee] = pydantic.Field(description="The employee on the plan.")
    provider_name: typing.Optional[str] = pydantic.Field(description="The name of the benefit provider.")
    benefit_plan_type: typing.Optional[str] = pydantic.Field(description="The type of benefit plan")
    employee_contribution: typing.Optional[float] = pydantic.Field(description="The employee's contribution.")
    company_contribution: typing.Optional[float] = pydantic.Field(description="The company's contribution.")
    start_date: typing.Optional[dt.datetime] = pydantic.Field(description="The day and time the benefit started.")
    end_date: typing.Optional[dt.datetime] = pydantic.Field(description="The day and time the benefit ended.")
    remote_was_deleted: typing.Optional[bool] = pydantic.Field(
        description="Indicates whether or not this object has been deleted by third party webhooks."
    )
    employer_benefit: typing.Optional[str] = pydantic.Field(
        description="The employer benefit plan the employee is enrolled in."
    )
    modified_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="This is the datetime that this object was last updated by Merge"
    )
    field_mappings: typing.Optional[typing.Dict[str, typing.Any]]
    remote_data: typing.Optional[typing.List[RemoteData]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
