# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .payroll_run_run_state import PayrollRunRunState
from .payroll_run_run_type import PayrollRunRunType
from .remote_data import RemoteData

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class PayrollRun(pydantic.BaseModel):
    """
    # The PayrollRun Object
    ### Description
    The `PayrollRun` object is used to represent a group of pay statements for a specific pay schedule.

    ### Usage Example
    Fetch from the `LIST PayrollRuns` endpoint and filter by `ID` to show all payroll runs.
    """

    id: typing.Optional[str]
    remote_id: typing.Optional[str] = pydantic.Field(description="The third-party API ID of the matching object.")
    run_state: typing.Optional[PayrollRunRunState] = pydantic.Field(
        description=(
            "The state of the payroll run\n"
            "\n"
            "* `PAID` - PAID\n"
            "* `DRAFT` - DRAFT\n"
            "* `APPROVED` - APPROVED\n"
            "* `FAILED` - FAILED\n"
            "* `CLOSED` - CLOSED\n"
        )
    )
    run_type: typing.Optional[PayrollRunRunType] = pydantic.Field(
        description=(
            "The type of the payroll run\n"
            "\n"
            "* `REGULAR` - REGULAR\n"
            "* `OFF_CYCLE` - OFF_CYCLE\n"
            "* `CORRECTION` - CORRECTION\n"
            "* `TERMINATION` - TERMINATION\n"
            "* `SIGN_ON_BONUS` - SIGN_ON_BONUS\n"
        )
    )
    start_date: typing.Optional[dt.datetime] = pydantic.Field(description="The day and time the payroll run started.")
    end_date: typing.Optional[dt.datetime] = pydantic.Field(description="The day and time the payroll run ended.")
    check_date: typing.Optional[dt.datetime] = pydantic.Field(
        description="The day and time the payroll run was checked."
    )
    remote_was_deleted: typing.Optional[bool] = pydantic.Field(
        description="Indicates whether or not this object has been deleted by third party webhooks."
    )
    modified_at: typing.Optional[dt.datetime] = pydantic.Field(
        description="This is the datetime that this object was last updated by Merge"
    )
    field_mappings: typing.Optional[typing.Dict[str, typing.Any]]
    remote_data: typing.Optional[typing.List[RemoteData]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
